#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum FftWindow {
    #[serde(rename = "BLACKMAN")]
    Blackman,
    #[serde(rename = "HANN")]
    Hann,
    #[serde(rename = "HAMMING")]
    Hamming,
    #[serde(rename = "RECT")]
    Rect,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl FftWindow {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            FftWindow::Blackman => "BLACKMAN",
            FftWindow::Hann => "HANN",
            FftWindow::Hamming => "HAMMING",
            FftWindow::Rect => "RECT",
            FftWindow::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for FftWindow {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for FftWindow {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for FftWindow {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(v: &str) -> Result<FftWindow, conjure_object::plain::ParseEnumError> {
        match v {
            "BLACKMAN" => Ok(FftWindow::Blackman),
            "HANN" => Ok(FftWindow::Hann),
            "HAMMING" => Ok(FftWindow::Hamming),
            "RECT" => Ok(FftWindow::Rect),
            v => v.parse().map(|v| FftWindow::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for FftWindow {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(v: &str) -> Result<FftWindow, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the FftWindow enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
